VERSION 5.00
Begin VB.UserControl mozCtl 
   ClientHeight    =   4425
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6795
   ScaleHeight     =   4425
   ScaleWidth      =   6795
   Begin VB.Timer tmrFocus 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   5040
      Top             =   180
   End
   Begin VB.Label lblDesignTimeCaption 
      BackColor       =   &H00FFFFFF&
      Caption         =   "mozilla-control-wrapper"
      Height          =   255
      Left            =   150
      TabIndex        =   0
      Top             =   180
      Visible         =   0   'False
      Width           =   1785
   End
End
Attribute VB_Name = "mozCtl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Event BeforeNavigate2(ByVal pDisp As Object, URL As Variant, Flags As Variant, TargetFrameName As Variant, PostData As Variant, Headers As Variant, Cancel As Boolean)
Event CommandStateChange(ByVal Command As Long, ByVal Enable As Boolean)
Event DocumentComplete(ByVal pDisp As Object, URL As Variant)
Event DownloadBegin()
Event DownloadComplete()
Event NavigateComplete2(ByVal pDisp As Object, URL As Variant)
Event NewWindow2(ppDisp As Object, Cancel As Boolean)
Event ProgressChange(ByVal Progress As Long, ByVal ProgressMax As Long)
Event PropertyChange(ByVal szProperty As String)
Event StatusTextChange(ByVal Text As String)
Event TitleChange(ByVal Text As String)
Event BrowserKeyPress(ByVal KeyAscii As Integer, targetTagName As String, targetID As String)
Event BrowserScroll(ByVal OffsetX As Long, ByVal OffsetY As Long)

Private WithEvents MC As MozillaBrowser
Attribute MC.VB_VarHelpID = -1

Private Unk As olelib.IUnknown
Private IOO As IOleObject
Private IOC As IOleClientSite
Private IPO As IOleInPlaceObject
Private ICS As IOleControlSite

Private LastStatusText As String, NavigateRunning As Boolean, mFocused As Boolean
Private mozVBFunctions As String, jsResult As String, LastTitle As String

Public HistoryList As New Collection, HistoryIndex As Long


'*** the following routines are for general Control-Initialization ***
Private Sub UserControl_Resize()
Dim Rct As RECT, Ext As VBControlExtender

  Init
  
  On Error Resume Next 'just in case the extender is not yet there
    Rct.Left = ScaleX(Extender.Left, Extender.Container.ScaleMode, vbPixels)
    Rct.Top = ScaleY(Extender.Top, Extender.Container.ScaleMode, vbPixels)
    Rct.Right = Rct.Left + ScaleX(Extender.Width, Extender.Container.ScaleMode, vbPixels)
    Rct.Bottom = Rct.Top + ScaleY(Extender.Height, Extender.Container.ScaleMode, vbPixels)
  If Err Then Err.Clear
  
  If Not IPO Is Nothing Then IPO.SetObjectRects Rct, Rct
End Sub

Private Sub Init()
Static Done As Boolean: If Done Then Exit Sub Else Done = True 'do it once only

Dim M As olelib.MSG, Rct As RECT

  If Not Ambient.UserMode Then
    lblDesignTimeCaption.Visible = True
    Exit Sub
  End If
  
  UserControl.BackStyle = 0
  
  Set Unk = GetMozInstance()
  Unk.AddRef

  Set IOO = Me
  Set IOC = IOO.GetClientSite
  Set ICS = IOC
 
  Set IOO = Unk
  IOO.SetHostNames App.Title, Extender.Name
  IOO.SetClientSite IOC
  
  IOO.DoVerb OLEIVERB_SHOW, M, IOC, -1, UserControl.ContainerHwnd, Rct
  IOO.DoVerb OLEIVERB_INPLACEACTIVATE, M, IOC, -1, UserControl.ContainerHwnd, Rct
  
  Set IPO = Unk
  Set MC = Unk
  
  MC.Navigate2 "about:blank"
  
'  Do While MC.Busy: DoEvents: Loop 'seems not to be necessary anymore in the new xulrunner
  
  tmrFocus.Enabled = True 'from now on, we watch "focus-issues" with a timer
  mozVBFunctions = GetTextContent(App.Path & "\mozVB.js")
End Sub
'*** End of Control-Inits ****************************

'*** Focus-Handling without SubClassing, to achieve a better "IDE-safety" ****
Private Sub tmrFocus_Timer()
Dim P As Point, WFP_hWnd&, CName As String
Static BackKeyDown As Boolean, FwdKeyDown As Boolean
  On Error Resume Next
  If Not Ambient.UserMode Then Exit Sub
  If ICS Is Nothing Then Exit Sub
  
  If GetActiveWindow <> UserControl.Parent.hwnd Then
    If mFocused Then UserControl_LostFocus
    Exit Sub
  End If
  If CheckMouseKeyDown Then
    GetCursorPos P
    WFP_hWnd = WindowFromPoint(P.x, P.y)
    CName = Space$(255)
    CName = Left$(CName, GetClassName(WFP_hWnd, CName, 255))
    If Left$(CName, 7) = "Mozilla" And Not mFocused Then
      UserControl_GotFocus
    End If
  End If
  
  'this handles the special MouseKeys for back/fwd-navigation
  '(in case you have a mouse, which does have them... ;-)
  If (GetAsyncKeyState(5) And &H8000) <> 0 Then
    BackKeyDown = True
  ElseIf (GetAsyncKeyState(6) And &H8000) <> 0 Then
    FwdKeyDown = True
  Else
    If BackKeyDown Then GoBack Else If FwdKeyDown Then GoForward
    BackKeyDown = False
    FwdKeyDown = False
  End If

  If Err Then Err.Clear
End Sub
Private Function CheckMouseKeyDown() As Boolean
  CheckMouseKeyDown = (GetAsyncKeyState(1) And &H8000) <> 0 Or (GetAsyncKeyState(2) And &H8000) <> 0
End Function

Public Sub ActivateFocus()
  UserControl_GotFocus
End Sub

Private Sub UserControl_GotFocus()
  If ICS Is Nothing Or IPO Is Nothing Then Exit Sub
  mFocused = True
  On Error Resume Next
    ICS.OnFocus mFocused
    SendMessage IPO.GetWindow, WM_SETFOCUS, 0, ByVal 0&
  If Err Then Err.Clear
End Sub
Private Sub UserControl_LostFocus()
  If ICS Is Nothing Or IPO Is Nothing Then Exit Sub
  mFocused = False
  On Error Resume Next
    ICS.OnFocus mFocused
    SendMessage IPO.GetWindow, WM_KILLFOCUS, 0, ByVal 0&
  If Err Then Err.Clear
End Sub
'******* End of the "special Focus-Handling" ******


'************* the following routines are for Event-Delegation into our App ************
Private Sub MC_BeforeNavigate2(ByVal pDisp As Object, URL As Variant, Flags As Variant, TargetFrameName As Variant, PostData As Variant, Headers As Variant, Cancel As Boolean)
  If URL = "about:blank" Then Exit Sub
  RaiseEvent BeforeNavigate2(pDisp, URL, Flags, TargetFrameName, PostData, Headers, Cancel)
End Sub

Private Sub MC_CommandStateChange(ByVal Command As Long, ByVal Enable As Boolean)
  RaiseEvent CommandStateChange(Command, Enable)
End Sub

Private Sub MC_DocumentComplete(ByVal pDisp As Object, URL As Variant)
  If Not Body Is Nothing Then
    AddElementContent Body, "<script id='mozVBFunctions'>" & mozVBFunctions & "</script>"
    AddElementContent Body, "<script>" & _
                               "document.body.addEventListener('DOMAttrModified', OnAttrModified, false);" & _
                               "document.body.addEventListener('keypress', BodyKeyHandler, false);" & _
                               "window.addEventListener('scroll', WindowScrollHandler, false);" & _
                            "</script>"
          
  End If
  RaiseEvent DocumentComplete(pDisp, URL)
End Sub

Private Sub MC_DownloadBegin()
  RaiseEvent DownloadBegin
End Sub

Private Sub MC_DownloadComplete()
  RaiseEvent DownloadComplete
End Sub

Private Sub MC_NavigateComplete2(ByVal pDisp As Object, URL As Variant)
  NavigateRunning = False
  RaiseEvent NavigateComplete2(pDisp, URL)
End Sub

Private Sub MC_NewWindow2(ppDisp As Object, Cancel As Boolean)
  RaiseEvent NewWindow2(ppDisp, Cancel)
End Sub

Private Sub MC_ProgressChange(ByVal Progress As Long, ByVal ProgressMax As Long)
Dim UrlIndex As Long

  UrlIndex = HistoryEntryExists(MC.LocationUrl)
  If UrlIndex <> HistoryIndex Or UrlIndex = 0 Then
    For UrlIndex = HistoryList.Count To HistoryIndex + 1 Step -1
      HistoryList.Remove UrlIndex
    Next UrlIndex

    HistoryList.Add MC.LocationUrl
    HistoryIndex = HistoryList.Count
  End If

  RaiseEvent ProgressChange(Progress, ProgressMax)
  If ProgressMax = &H7FFFFFFF Then MC_StatusTextChange vbNullString
End Sub

Private Sub MC_PropertyChange(ByVal szProperty As String)
  RaiseEvent PropertyChange(szProperty)
End Sub

Private Sub MC_StatusTextChange(ByVal Text As String)
  If Len(Text) Then
    If NavigateRunning Then
      LastStatusText = Text
    Else
      If Asc(Right$(Text, 1)) = 133 Then Exit Sub
    End If
    RaiseEvent StatusTextChange(Text)
  Else
    RaiseEvent StatusTextChange(LastStatusText)
  End If
End Sub

Private Sub MC_TitleChange(ByVal Text As String)
Static BlockNextEvent As Boolean, sArr() As String
  If BlockNextEvent Then BlockNextEvent = False: Exit Sub
  
  If Left$(Text, 2) = "||" Then 'coming from JavaScript
    BlockNextEvent = True
    If Left$(Text, 3) = "|||" Then 'resultvalue of a JavaScript-Call
      jsResult = Mid$(Text, 4)
    Else 'jscript-Event-Mechanism
      sArr = Split(Mid$(Text, 4), "|")
      If Left$(Text, 3) = "||s" Then
        RaiseEvent BrowserScroll(sArr(0), sArr(1))
      ElseIf Left$(Text, 3) = "||k" Then
        RaiseEvent BrowserKeyPress(sArr(0), sArr(1), sArr(2))
      End If
      If Not Document Is Nothing Then Document.Title = LastTitle
      DoEvents
    End If
  Else 'normal Title-Change
    LastTitle = Text
    RaiseEvent TitleChange(Text)
  End If
End Sub
'*** End of Event-Delegation **********************************


'*** and finally the Public Method-Delegation, please enhance that as you need it *********

Public Function CallJS(FunctionName As String, ParamArray Params()) As String
Dim i As Long, strArr() As String, CurCall As String
Static LastCall As String
  jsResult = vbNullString
  
  If Len(FunctionName) = 0 Then 'only an Eval()-request
    If UBound(Params) < 0 Then Exit Function
    CurCall = Params(0)
  Else
    If UBound(Params) < 0 Then
       CurCall = FunctionName & "();"
    Else
      ReDim strArr(UBound(Params))
      For i = 0 To UBound(strArr)
        If VarType(Params(i)) = vbString Then
          strArr(i) = """" & Params(i) & """"
        Else
          strArr(i) = Params(i)
        End If
      Next i
      CurCall = FunctionName & "(" & Join(strArr, ",") & ");"
    End If
  End If
  If CurCall = LastCall Then CurCall = CurCall & " "
  LastCall = CurCall
  If Not Body Is Nothing Then
    Body.setAttribute "jscall", CurCall
      DoEvents
    CallJS = jsResult
    Document.Title = LastTitle 'reset the title
      DoEvents
  End If
End Function

Public Property Get MCDisp() As Object
  Set MCDisp = MC
End Property

Public Sub Navigate2(URL, Optional Flags, Optional TargetFrameName, Optional PostData, Optional Headers)
  If MC Is Nothing Then Exit Sub
  CancelRequest
  On Error Resume Next
    MC.Navigate2 URL, Flags, TargetFrameName, PostData, Headers
  If Err Then Err.Clear: Exit Sub
  NavigateRunning = True
End Sub

Public Sub GoBack()
  If MC Is Nothing Then Exit Sub
  If HistoryList.Count = 0 Then Exit Sub
  If HistoryIndex > HistoryList.Count Then HistoryIndex = HistoryList.Count
  If HistoryIndex < 1 Then HistoryIndex = 1
  If HistoryIndex > 1 Then HistoryIndex = HistoryIndex - 1
  Navigate2 HistoryList(HistoryIndex)
End Sub

Public Sub GoForward()
  If MC Is Nothing Then Exit Sub
  If HistoryList.Count = 0 Then Exit Sub
  If HistoryIndex > HistoryList.Count Then HistoryIndex = HistoryList.Count
  If HistoryIndex < 1 Then HistoryIndex = 1
  If HistoryIndex < HistoryList.Count Then HistoryIndex = HistoryIndex + 1
  Navigate2 HistoryList(HistoryIndex)
End Sub

Public Sub GoHome()
  If MC Is Nothing Then Exit Sub
  MC.GoHome
End Sub

Public Sub GoSearch()
  If MC Is Nothing Then Exit Sub
  Navigate2 "http://www.google.com"
End Sub

Public Sub RefreshPage()
  If MC Is Nothing Then Exit Sub
  MC.Refresh
End Sub

Public Sub CancelRequest()
  If MC Is Nothing Then Exit Sub
  MC.Stop
End Sub

Public Property Get LocationUrl() As String
  If MC Is Nothing Then Exit Sub
  LocationUrl = MC.LocationUrl
End Property

Public Property Get Document() As IHTMLDocument2
  If MC Is Nothing Then Exit Property
  Set Document = MC.Document
End Property

Public Property Get Head() As IHTMLElement
  If Document Is Nothing Then Exit Property
Dim i&, Children As IHTMLElementCollection, Elmt As IHTMLElement
  On Error Resume Next
  Set Children = Document.All
  For i = 0 To 20 'check within the first 20 Elements only
    Set Elmt = Children.Item(i)
    If StrComp("HEAD", Elmt.TagName, vbTextCompare) = 0 Then
      Set Head = Elmt
      Exit For
    End If
  Next i
  If Err Then Err.Clear
End Property

Public Property Get Body() As IHTMLElement
  If Document Is Nothing Then Exit Property
  Set Body = MC.Document.Body
End Property

Public Property Get BodyContent() As String
  If Body Is Nothing Then Exit Property
  BodyContent = Body.innerHTML
End Property
Public Property Let BodyContent(NewHTMLBodyContent As String)
  If Body Is Nothing Then Exit Property
  With Body
    If Len(.innerHTML) = 0 Then
      .insertAdjacentHTML "beforeEnd", NewHTMLBodyContent
    Else
      .innerHTML = NewHTMLBodyContent
    End If
  End With
End Property

Public Function GetElementByTagName(TagName As String) As IHTMLElement
  If Document Is Nothing Then Exit Function
Dim i&, Children As IHTMLElementCollection, Elmt As IHTMLElement
  Set Children = Document.All
  For i = 0 To Children.length - 1
    Set Elmt = Children.Item(i)
    If StrComp(TagName, Elmt.TagName, vbTextCompare) = 0 Then
      Set GetElementByTagName = Elmt
      Exit For
    End If
  Next i
End Function

Public Function GetChildElementById(ID As String, Optional ElementToSearchWithin As IHTMLElement) As IHTMLElement
Dim Children As IHTMLElementCollection
  If MC Is Nothing Then Exit Function
  If ElementToSearchWithin Is Nothing Then Set ElementToSearchWithin = Body
  Set Children = ElementToSearchWithin.Children
  Set GetChildElementById = Children.Item(ID)
End Function

Public Function GetTextContent(FileName As String) As String
Dim FNr As Long
  FNr = FreeFile
  Open FileName For Binary Access Read As FNr
    GetTextContent = Space$(LOF(FNr))
    Get FNr, , GetTextContent
  Close FNr
End Function

Public Sub AddElementContent(ToElement As IHTMLElement, NewHTMLElementContent As String)
  ToElement.insertAdjacentHTML "beforeEnd", NewHTMLElementContent
End Sub

Private Function HistoryEntryExists(URL As String) As Long
Dim i&
  For i = HistoryList.Count To 1 Step -1
    If StrComp(HistoryList(i), URL, vbTextCompare) = 0 Then
      HistoryEntryExists = i
      Exit Function
    End If
  Next i
End Function

Private Sub UserControl_Terminate()
  Set IOC = Nothing
  Set IPO = Nothing
  Set ICS = Nothing
End Sub


